#!/usr/bin/env node

var hipchat = require('node-hipchat');
var program = require('commander');
var co      = require('co');
var prompt  = require('co-prompt');

var message = "";
var action  = "";
program
  .version('0.0.1')
  .option('-k, --key <key>', 'Hipchat key to use to post a message')
  .option('-r, --room <room>', 'Hipchat key to use to post a message')
  .option('-u, --username <username>', 'Username to display as emitter')
  .option('-c, --color <color>', 'Color of the message')
  .option('-m, --message <message>', 'Message to display')
  .option('-l, --list <item>', 'Lists [rooms|users] (needs an admin key)')
  .parse(process.argv);

// admin key
//var HC = new hipchat('9ef1033fc680e25ca4cade72f53fc8');
// user key
//var HC = new hipchat('da5bb9861e4324593e2ee630e8071f');

if (!program.key) {
    program.help();
}

var HC = new hipchat(program.key);

if(program.list === 'rooms') {
    HC.listRooms(function(data) {
        console.log(data); // These are all the rooms
        process.exit(0);
    });
}
if(program.list === 'users') {
    HC.listUsers(function(data) {
        console.log(data); // These are all the rooms
        process.exit(0);
    });
}
else if (!program.room || !program.username) {
    program.help();
}

/*if(program.message) {
    message = program.message;
}
else {
    co(function *() {
        message = yield prompt('Message : ');
    }
}*/

var params = {
  room: program.room,
  from: program.username,
  message: program.message,
  color: program.color || 'blue'
};

HC.postMessage(params, function(data) {
  // Message has been sent!
  console.log('Done');
});

